/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoSvnConf]のクラス
 */
package blanco.svnconf.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.svnconf.task.valueobject.BlancoSvnConfProcessInput;

/**
 * Apache Antタスク [BlancoSvnConf]のクラス。
 *
 * Subversionリポジトリ定義書から設定ファイルを自動生成するためのAntTaskです。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.svnconf.task]にBlancoSvnConfBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancosvnconf&quot; classname=&quot;blanco.svnconf.task.BlancoSvnConfTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoSvnConfTask extends Task {
    /**
     * Subversionリポジトリ定義書から設定ファイルを自動生成するためのAntTaskです。
     */
    protected BlancoSvnConfProcessInput fInput = new BlancoSvnConfProcessInput();

    /**
     * Subversionリポジトリ定義書から設定ファイルを自動生成するためのAntTaskです。
     */
    protected boolean fIsFieldMetadirProcessed = false;

    /**
     * Subversionリポジトリ定義書から設定ファイルを自動生成するためのAntTaskです。
     */
    protected boolean fIsFieldTargetdirProcessed = false;

    /**
     * Subversionリポジトリ定義書から設定ファイルを自動生成するためのAntTaskです。
     */
    protected boolean fIsFieldTmpdirProcessed = false;

    /**
     * Subversionリポジトリ定義書から設定ファイルを自動生成するためのAntTaskです。
     */
    protected boolean fIsFieldAcceptLowerCaseUserNameProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[metadir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * メタディレクトリ。xlsファイルの格納先または xmlファイルの格納先を指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setMetadir(final String arg) {
        fInput.setMetadir(arg);
        fIsFieldMetadirProcessed = true;
    }

    /**
     * Antタスクの[metadir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * メタディレクトリ。xlsファイルの格納先または xmlファイルの格納先を指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getMetadir() {
        return fInput.getMetadir();
    }

    /**
     * Antタスクの[targetdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力先フォルダを指定します。無指定の場合にはカレント直下のblanco.svnconfを用います。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetdir(final String arg) {
        fInput.setTargetdir(arg);
        fIsFieldTargetdirProcessed = true;
    }

    /**
     * Antタスクの[targetdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力先フォルダを指定します。無指定の場合にはカレント直下のblanco.svnconfを用います。<br>
     * デフォルト値[blanco.svnconf]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetdir() {
        return fInput.getTargetdir();
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     *
     * @param arg セットしたい値
     */
    public void setTmpdir(final String arg) {
        fInput.setTmpdir(arg);
        fIsFieldTmpdirProcessed = true;
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     * デフォルト値[tmp]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTmpdir() {
        return fInput.getTmpdir();
    }

    /**
     * Antタスクの[acceptLowerCaseUserName]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * 小文字化されたユーザ名を受け付けるかどうか。環境により ユーザ名が 小文字で Subversion認証に渡される現象があるが、これに対応するためのフラグ。<br>
     *
     * @param arg セットしたい値
     */
    public void setAcceptLowerCaseUserName(final boolean arg) {
        fInput.setAcceptLowerCaseUserName(arg);
        fIsFieldAcceptLowerCaseUserNameProcessed = true;
    }

    /**
     * Antタスクの[acceptLowerCaseUserName]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * 小文字化されたユーザ名を受け付けるかどうか。環境により ユーザ名が 小文字で Subversion認証に渡される現象があるが、これに対応するためのフラグ。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getAcceptLowerCaseUserName() {
        return fInput.getAcceptLowerCaseUserName();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoSvnConfTask begin.");

        // 項目番号[1]、アトリビュート[metadir]は必須入力です。入力チェックを行います。
        if (fIsFieldMetadirProcessed == false) {
            throw new BuildException("必須アトリビュート[metadir]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- metadir:[" + getMetadir() + "]");
            System.out.println("- targetdir:[" + getTargetdir() + "]");
            System.out.println("- tmpdir:[" + getTmpdir() + "]");
            System.out.println("- acceptLowerCaseUserName:[" + getAcceptLowerCaseUserName() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoSvnConfProcessインタフェースを実装して blanco.svnconf.taskパッケージに BlancoSvnConfProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoSvnConfProcess proc = new BlancoSvnConfProcessImpl();
            if (proc.execute(fInput) != BlancoSvnConfBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
